%define releasebase 3 
%define nbase  openmpi
%define modpath /opt/Modules
# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc

#Use as deafults if no command line inputs
%define as_limulus 1
# NOTE: compilers are mutually exclusive, only set one,
#       if not using command line options
#       !not all compilers have been implemented and tested!
%define use_gnu4  1
%define use_gnu3 0
%define use_pgi  0
%define use_intel 0
%define use_pathsc 0
# High speed interconnect modules (best to use --with 
%define with_openib 0 
%define with_gm     0
%define with_mx     0
%define with_open_mx  0
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
%{?_with_oib: %{expand: %%define with_openib 1}}
%{?_with_gm: %{expand: %%define with_gm 1}}
%{?_with_mx: %{expand: %%define with_mx 1}}
%{?_with_omx: %{expand: %%define with_open_mx 1}}

%define prefixbase  /opt/mpi

#pick the target Limulus is default
%if "1" == "%{as_basement}"
%define _prefix 	%{prefixbase}/%{fullname}
%define moduleroot       %{prefixbase}/%{name}
%define _docdir 	%{_prefix}/doc
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define _prefix %{afsroot}/%{afsarch}%{prefixbase}/%{fullname}
%define moduleroot      %{afsroot}/%{afsarch}%{prefixbase}/%{name}
%define  _defaultdocdir %{afsroot}/%{afsarch}/%{_usr}/share/doc
%define targetbase afs_%{afsarch}
%else
%define _prefix 	 %{prefixbase}/%{fullname}
%define moduleroot       %{prefixbase}/%{name}
%define _docdir 	%{_prefix}/doc
%define targetbase Limulus
%endif
%endif

Summary:OpenMPI 
Version: 1.4.2
Vendor:  Basement Supercomputing
Packager: Douglas Eadline <deadline@basement-supercomuting.com>
License: GNU
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
URL: http://www.oenmpi.org/

#
# HISTORY
# This spec file was inspired by spec files created by others for MPICH,
# including the Scyld version, written by Frederick (Rick) Niles of Scyld, and 
# included as mpich-scyld.spec in the MPICH source distribution.
#
# Spec file modified by Joe Landman for MPICH 1.2.6 with specific options
# and fixes to enable correct builds with RedHat, FCx, SuSE, ...
# placed mpich in /opt/mpich-1.2.6, and set the /etc/profile.d/mpich.*
# to point to it.
# again modified by Joe Landman to deal with mpich2-1.0.3.
#
# Modified by Doug Eadline to build Open MPI


#
# Known to work:  gnu, soon {pgi, pathsc, intel}
# Probably does not work: absoft, lahey, nag
#
# Currently using GNU 4 platform (FC4), probably should put in
# test here to see what version (3 or 4) of gnu 
%if "1" == "%{use_gnu3}"
    %define c_compiler gcc
    %define compiler_path /usr/bin
    %define setenvs export FC=%{compiler_path}/g77;  export LDFLAGS="-Wl,-z,noexecstack"
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define mpif90 no 
Name: %{nbase}-gnu3
%endif
%if "1" == "%{use_gnu4}"
    %define c_compiler gcc
    %define compiler_path /usr/bin
    %define setenvs export FC=%{compiler_path}/gfortran;  export F90=%{compiler_path}/gfortran export LDFLAGS="-Wl,-z,noexecstack"
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define mpif90 yes 
Name: %{nbase}-gnu4
%endif
%if "1" == "%{use_absoft}"
    %define c_compiler gcc
    %define compiler_path /usr/absoft
    %define setenvs export ABSOFT=%{compiler_path}; export FC=%{compiler_path}/bin/f77; export F90=%{compiler_path}/bin/f90
    %define fopts --without-mpe
    %define extralibs -L%{compiler_path}/lib -lU77 -lf77math
    %define extraldopts %{extralibs}
    %define mpif90 yes 
Name: %{nbase}-absoft
%endif
%if "1" == "%{use_intel}"
    %define setenvs export FC=ifort; export F90=$FC;  export CC=icc; export CXX=icpc;
    %define fopts %{nil}
    %define extralibs -lirc
    %define extraldopts  -L/opt/intel/fc/9.1.039/lib %{extralibs}
%ifarch x86_64
    %define extraldopts  -L/opt/intel/fce/9.1.039/lib %{extralibs}
%endif
    %define mpif90 yes 
Name: %{nbase}-intel
%endif
%if "1" == "%{use_pgi}"
    %define c_compiler pgicc
    %define compiler_path /usr/pgi/linux86
    %define setenvs export PATH=$PATH:%{compiler_path}/bin; export PGI=%{compiler_path}/..; export CC="%{compiler_path}/bin/pgcc"; export FC="/usr/pgi/linux86/bin/pgf77"; export F90="%{compiler_path}/bin/pgf90"
    %define fopts %{nil}
    %define extralibs -L%{compiler_path}/lib -lpgc
    %define extraldopts -L%{compiler_path}/lib -lpgc
    %define mpif90 yes 
Name: %{nbase}-pgi
%endif
%if "1" == "%{use_lahey}"
    %define c_compiler gcc
    %define compiler_path /usr/local/lf9561
    %define setenvs export PATH=%{compiler_path}/bin:$PATH; export LD_LIBRARY_PATH=%{compiler_path}/lib:$LD_LIBRARY_PATH; export FC=%{compiler_path}/bin/lf95; export F90=%{compiler_path}/bin/lf95
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define mpif90 yes 
Name: %{nbase}-lahey
%endif
%if "1" == "%{use_nag}"
    %define c_compiler gcc
    %define compiler_path /usr/local
    %define setenvs export FC=%{compiler_path}/bin/f95; export F90=%{compiler_path}/bin/f95
    %define fopts --with-f95nag
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define mpif90 yes 
Name: %{nbase}-nag
%endif

Source0:openmpi-%{version}.tar.bz2
Buildroot: %{_tmppath}/%{name}-root
#BuildRequires: %{c_compiler}
Provides: libmpi.a libopal.a liborte.a
Requires: modules
%define fullname %{name}-%{version}

# Define alternate root directories for installation here
%define _wrapperprefix 	 %{prefixbase}/%{name}
%define _mandir 	%{_prefix}/man
%define _exec_prefix  	%{_prefix}/bin
%define _bindir  	%{_prefix}/bin
%ifnarch x86_64
%define _libdir  	%{_prefix}/lib
%endif
%ifarch x86_64
%define _libdir  	%{_prefix}/lib64
%endif
%define _sharedir  	%{_prefix}/share
%define _datadir  	%{_sharedir}
%define _includedir  	%{_prefix}/include
%define _etcdir		%{_prefix}/etc
# not used for this version
#%define _sbindir  	%{_prefix}/sbin
#%define _docdir  	%{_prefix}/doc
#%define _exampledir	%{_prefix}/examples
#%define _webdir 	%{_prefix}/www


#
# If these are changed, make sure that you change the directories selected 
# under the files step. 
# DJE - 4/15/2006
# When the code builds it needs the real
# datadir (i.e. no build root path) because the path is passed
# as a define to by make during the build and used by the binariers.
# When installing, you need use the acutual buildroot path. 
# To fix this we change the appropriate Makefiles in the install section

#%define prefixdir   	%{?buildroot:%{buildroot}}%{_prefix}
#%define sharedir 	%{?buildroot:%{buildroot}}%{_sharedir}
#%define libdir   	%{?buildroot:%{buildroot}}%{_libdir}
%define prefixdir   %{_prefix}
%define sharedir 	%{_sharedir}
%define libdir   	%{_libdir}
%define datadir 	%{_datadir}


%define exec_prefix 	%{?buildroot:%{buildroot}}%{_exec_prefix}
%define bindir 		%{?buildroot:%{buildroot}}%{_bindir}
# most of these are needed by this version
#%define mandir   	%{?buildroot:%{buildroot}}%{_mandir}
#%define sbindir 	%{?buildroot:%{buildroot}}%{_sbindir}
#%define docdir 	%{?buildroot:%{buildroot}}%{_docdir}
#%define example_dir     %{?buildroot:%{buildroot}}%{_exampledir}

# Choose whether you want all .h files in a common include dir or one
# with the mpich name in it
%define includedir %{?buildroot:%{buildroot}}%{_includedir}

%define webdir 		%{?buildroot:%{buildroot}}%{_webdir}


%description 
Open MPI is a project combining technologies and resources from several other projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best MPI library available. A completely new MPI-2 compliant implementation, Open MPI offers advantages for system and software vendors, application developers and computer science researchers.


%package node
Summary: OpenMPI Node Files
Group: %{targetbase}/Libraries
License: GNU 
Release: %{releasebase}.%{targetbase}

%description node
OpenMPI files needed for Perceus nodes.
To be installed in vnfs capsules.





%prep
%setup -q -n %{nbase}-%{version}

%build
echo PREFIX %{_prefix}
%setenvs
%if "1" == "%{intel}"
    %ifarch x86_64
      source /opt/intel/cce/9.1.044/bin/iccvars.sh
      source  /opt/intel/fce/9.1.039/bin/ifortvars.sh 
    %else 
      source /opt/intel/cc/9.1.044/bin/iccvars.sh
      source  /opt/intel/fc/9.1.039/bin/ifortvars.sh 
    %endif
    export CC=`which icc`
    export FC=`which ifort`
    export F77=`which ifort`
%endif

%if "1" == "%{with_openib}"
%define openib_libs  "--with-openib=/opt/ofed-1.1"
%else
%define openib_libs %{nil} 
%endif
%if "1" == "%{with_gm}"
%define openib_libs  "--with-gm=/usr/gm"
%else
%define openib_libs %{nil} 
%endif
%if "1" == "%{with_mx}"
%define mx_libs  "--with-mx=/opt/mx"
%else
%define mx_libs %{nil}
%endif
%if "1" == "%{with_open_mx}"
%define mx_libs  "--with-mx=/usr/open-mx"
%define omx_ld_library_path :/usr/open-mx/lib
%else
%define mx_libs %{nil}
%define omx_ld_library_path %{nil}
%endif

echo %{datadir}
%ifnarch x86_64
./configure \
	--prefix=%{prefixdir} --enable-mca-no-build=maffinity-libnuma,btl-portals\
	--datadir=%{datadir} --libdir=%{libdir} --enable-static  --disable-shared --with-wrapper-libs="-L%{_wrapperprefix}/lib %{extraldopts}" --with-wrapper-cflags=-I%{_wrapperprefix}/include --with-wrapper-fcflags=-I%{_wrapperprefix}/include --with-wrapper-cxxflags=-I%{_wrapperprefix}/include --with-wrapper-fflags=-I%{_wrapperprefix}/include --enable-mpi-f90=%{mpif90} %{openib_libs} %{mx_libs} --with-sge

%endif
%ifarch x86_64
./configure \
	--prefix=%{prefixdir} --enable-mca-no-build=maffinity-libnuma,btl-portals\
        --datadir=%{datadir} --enable-static  --libdir=%{libdir} --with-wrapper-libs="-L%{_wrapperprefix}/lib64 %{extraldopts}" --with-wrapper-cflags=-I%{_wrapperprefix}/include  --with-wrapper-fcflags=-I%{_wrapperprefix}/include --with-wrapper-cxxflags=-I%{_wrapperprefix}/include  --with-wrapper-fflags=-I%{_wrapperprefix}/include  CFLAGS="-fPIC" CXXFLAGS="-fPIC" FCFLAGS=" -fPIC" --enable-mpi-f90=%{mpif90} %{openib_libs} %{mx_libs} --with-sge

%endif	

# The wrappers Makefile has the libdir and prefix with the buildroot attached
# remove the build root so the wrapper builds with right path
# fixing ompi/tools/wrappers/Makefile
/bin/cp ompi/tools/wrappers/Makefile  ompi/tools/wrappers/Makefile.build
sed 's!libdir = %{?buildroot:%{buildroot}}%{_libdir}!libdir = %{_libdir}!g' ompi/tools/wrappers/Makefile.build >ompi/tools/wrappers/Makefile
/bin/cp ompi/tools/wrappers/Makefile  ompi/tools/wrappers/Makefile.build1
sed 's!prefix = %{?buildroot:%{buildroot}}%{_prefix}!prefix = %{_prefix}!g' ompi/tools/wrappers/Makefile.build1 >ompi/tools/wrappers/Makefile

%{__make}
 
%install
%setenvs
# Change Makefiles so install path datadir is correct

#FIX_LIST=`find . -name Makefile -print`
#for FIX in $FIX_LIST ; do
#/bin/cp  $FIX $FIX.install
#sed 's!datadir = %{datadir}!datadir =  %{?buildroot:%{buildroot}}%{datadir}!g' $FIX.install > $FIX
#done


# put prefix back to normal for install, we removed it above to get wrapper to work correctly

#/bin/cp ompi/tools/wrappers/Makefile  ompi/tools/wrappers/Makefile.install1
#sed 's!prefix = %{_prefix}!prefix = %{?buildroot:%{buildroot}}%{_prefix}!g' ompi/tools/wrappers/Makefile.install1 >ompi/tools/wrappers/Makefile

make  DESTDIR=%{buildroot} install

# create /etc/ld.so.conf.d/
echo "Creating /etc/ld.so.conf.d/%{name} file"
mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d
cat <<EOF>> $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{name}.conf
%{_libdir}/
EOF

#


%post	
/sbin/ldconfig
# We link the dir name without the version. This way things like SGE
# can use the general name without needing to use the version info
# which will change.
cd %{_prefix}/..
ln -snbf %{name}-%{version} %{name}
/sbin/ldconfig
# now make the module file
/bin/mkdir -p  %{modpath}/modulefiles/mpi
cat <<EOF > %{modpath}/modulefiles/mpi/%{name}
#%Module1.0#######################################################################
## mpi/mpich modulefile
##
## Copyright (c) 2006 Basement Supercomputing

conflict mpi

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing mpi/%{name} version %{version}\n"
}

module-whatis "mpi/%{name}"
module-log error none
set libarch lib
set arch1  x86_64
set arch2 [ exec arch ]
if {\$arch1 == \$arch2 } {
  set libarch lib64
}

set currentmod \$env(HOME)/.currentmodules
set currentstring "module load mpi/%{name}"
set mpiroot %{moduleroot}
if [ module-info mode load ] {
        setenv MPIPATH \$mpiroot
        setenv OMPI_HOME \$mpiroot
        append-path MANPATH \$mpiroot/share/man
        prepend-path PATH \$mpiroot/bin
        prepend-path  LD_LIBRARY_PATH \$mpiroot/\$libarch%{omx_ld_library_path}
        if { ! [catch {open \$currentmod {RDWR CREAT}} usermod]} {
                set all [read \$usermod]
                if { ! [ regexp \$currentstring \$all ]} {
                        puts \$usermod \$currentstring
                }
                close \$usermod
        }
}
if [ module-info mode remove ] {
        unsetenv MPIPATH
        unsetenv OMPI_HOME
        remove-path MANPATH \$mpiroot/share/man
        remove-path PATH \$mpiroot/bin
        remove-path LD_LIBRARY_PATH \$mpiroot/\$libarch%{omx_ld_library_path}
        if { ! [catch {open \$currentmod r} userdel]} {
                set output ""
                foreach line [split [read \$userdel] \n] {
                        if { \$line!={} && ! [regexp [append currentstring "$"] \$line]} {
                                append output \$line "\n"
                        }
                }
                close \$userdel
        }
        if { ! [catch {open \$currentmod w} userdel]} {
                puts \$userdel \$output
                close \$userdel
        }
}
EOF

%post node
/sbin/ldconfig 2>/dev/null

%postun
/sbin/ldconfig 2>/dev/null
/bin/rm  %{modpath}/modulefiles/mpi/%{name}

%postun node
/sbin/ldconfig 2>/dev/null

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
%doc README LICENSE 
%{_bindir}/*
%{_etcdir}/*
%{_includedir}/*
%{_libdir}/*
%{_sharedir}/*
%{_sysconfdir}/ld.so.conf.d/*

%files node
%{_sysconfdir}/ld.so.conf.d/*

%changelog
* Fri Jul 23 2010  Douglas Eadline <deadline@basement-supercomuting.com>
- updated for AFS install option
* Tue Feb 13 2006  Douglas Eadline <deadline@basement-supercomuting.com>
- Lots of changes for open MPI version 1.0.1
* Wed Jul 06 2005 Joe Landman <landman@scalableinformatics.com>
- fixed the AMD64 bug
* Wed Jul 06 2005 Joe Landman <landman@scalableinformatics.com>
- Update to mpich2-1.0.2 with various options.
* Fri Dec 10 2004 Joe Landman <landman@scalableinformatics.com>
- Update to mpich 1.2.6 with various options.
* Fri Jan 10 2003 Willam Gropp <gropp@mcs.anl.gov>
- Update to MPICH 1.2.5 and fixed buildroot
* Thu Apr 25 2002 William Gropp <gropp@mcs.anl.gov>
- Initial version

